from typing import Pattern, Dict


def apply(subject: str, regex_pattern: Pattern) -> Dict[str, str]:
    match = regex_pattern.search(subject)
    if match is not None:
        groupdict = match.groupdict()
        groupdict['_subject'] = subject
        return groupdict
    else:
        raise ValueError('subject doesn\'t match regex pattern')
